#include <machine/asmacros.h>

#include "intrfault_assym.s"

	.text
	SUPERALIGN_TEXT
#ifdef __i386__
IDTVEC(intrfault_swint_handler)
	PUSH_FRAME
	SET_KERNEL_SREGS
	call intrfault_handler
	POP_FRAME
	iret

IDTVEC(intrfault_ipi_handler)
	PUSH_FRAME
	SET_KERNEL_SREGS
	movl lapic, %eax
	movl $0, LA_EOI(%eax)
	call intrfault_handler
	POP_FRAME
	iret
#else	/* __amd64__ */
IDTVEC(intrfault_swint_handler)
	PUSH_FRAME
	call intrfault_handler
	POP_FRAME
	iretq

IDTVEC(intrfault_ipi_handler)
	PUSH_FRAME
	movq lapic, %rax
	movl $0, LA_EOI(%rax)
	call intrfault_handler
	POP_FRAME
	iretq
#endif
